import org.junit.Test;

import static org.hamcrest.CoreMatchers.is;
import static org.junit.Assert.assertThat;

public class Aufgabe2Test {

    @Test
    public void testEmptyToString() throws Exception {

        Tree tree = new Tree();

        assertThat(tree.toString().replaceAll("\\s", ""), is("[]"));

    }

    @Test
    public void testToString() throws Exception {

        Tree tree = new Tree();

        tree.add(1);
        tree.add(4);
        tree.add(3);
        tree.add(2);
        tree.add(5);
        tree.add(2);

        assertThat(tree.toString().replaceAll("\\s", ""), is("[1,2,2,3,4,5]"));

    }

    @Test
    public void testEmptyCountLeaves() throws Exception {

        Tree tree = new Tree();

        assertThat(tree.countFromLevel(0), is(0));

    }

    @Test
    public void testCountLevelAll() throws Exception {

        Tree tree = new Tree();

        tree.add(5);
        tree.add(2);
        tree.add(1);
        tree.add(7);
        tree.add(6);
        tree.add(8);

        assertThat(tree.countFromLevel(0), is(6));

    }

    @Test
    public void testCountLevel1() throws Exception {

        Tree tree = new Tree();

        tree.add(5);
        tree.add(2);
        tree.add(1);
        tree.add(7);
        tree.add(6);
        tree.add(8);

        assertThat(tree.countFromLevel(1), is(5));

    }

    @Test
    public void testCountLevel2() throws Exception {

        Tree tree = new Tree();

        tree.add(5);
        tree.add(2);
        tree.add(1);
        tree.add(7);
        tree.add(6);
        tree.add(8);

        assertThat(tree.countFromLevel(2), is(3));

    }

    @Test
    public void testToStringLeavesEmpty() throws Exception {

        Tree tree = new Tree();

        assertThat(tree.toStringLeafs(), is("[]"));

    }

    @Test
    public void testToStringLeavesOneElem() throws Exception {

        Tree tree = new Tree();

        tree.add(5);

        assertThat(tree.toStringLeafs(), is("[5]"));

    }

    @Test
    public void testToStringLeaves5() throws Exception {

        Tree tree = new Tree();

        tree.add(5);
        tree.add(2);
        tree.add(1);
        tree.add(7);
        tree.add(6);

        assertThat(tree.toStringLeafs(), is("[1,6]"));

    }

    @Test
    public void testToStringLeaves6() throws Exception {

        Tree tree = new Tree();

        tree.add(5);
        tree.add(2);
        tree.add(1);
        tree.add(7);
        tree.add(6);
        tree.add(8);

        assertThat(tree.toStringLeafs(), is("[1,6,8]"));

    }


}